#ifndef LINT
#endif
/*
NOESY Pure shift pulse sequence using modified Zangger-Sterk method + noesyAC
Parameter setting:
        sw1     should be large compared to multiplet width
        gzlvl4  should be set so that the profile width exceeds the range 
                of chemical shifts
        selective pulse (selpw/selpwr/selshape) should have bandwidth less 
                than the smallest shift difference to be decoupled
                recommendations: reburp if long T2, rsnob if short
*/
#include <standard.h>
#include <Pbox_psg.h>
static int ph1[2]  = {0,2}; 
static int ph2[32] = {0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3};
static int ph3[8]  = {0,0,1,1,2,2,3,3};
static int ph4[32] = {0,2,1,3,2,0,3,1,2,0,3,1,0,2,1,3,0,2,1,3,2,0,3,1,2,0,3,1,0,2,1,3};
pulsesequence()
{
/* Define */ 
  double
gzlvl1, gzlvl2, gzlvl3, gzlvl4, gzlvl_ss, gzlvl_max,
gt1, gt2, gt3, gtss,
gstab, mix,
selpw, selpwr, droppts;
  int iphase;
  char sspul[MAXSTR], selshape[MAXSTR], lockcomp[MAXSTR];
/* Load Variables */
        gzlvl1=getval("gzlvl1"),                /* Filter gradients, NOESY block */
        gzlvl2=getval("gzlvl2"),                /* CTP selection gradient */
        gzlvl3=getval("gzlvl3"),                /* Spoiler pulse for the NOESY block */
        gzlvl4=getval("gzlvl4"),                /* Slice select gradient, ZS block  */
gzlvl_max=32767,
        gzlvl_ss=getval("gzlvl_ss"),            /* steady-state crusher gradient  */
        gt1=getval("gt1"),                      /* gradient time for NOESY filter gradients */
        gt2=getval("gt2"),                      /* gradient time, CTP for the ZS block*/
        gt3=getval("gt3"),                      /* gradient time, spoiler for the NOESY block*/
        gtss=getval("gtss"),
        gstab=getval("gstab"),                  /* gradient stabilisation delay for the NOESY block */
        selpw=getval("selpw"),                  /* pulse length for the soft 180, ZS block  */        selpwr=getval("selpwr"),                /* power level  for the soft 180, ZS block  */
        droppts = getval("droppts");            /* number of dummy points to acquire */
        mix = getval("mix");                    /* Mixing time for the NOESY in seconds */
        iphase=(getval("phase") + 0.5);  
getstr("sspul",sspul);
getstr("lockcomp",lockcomp);
getstr("selshape",selshape);
/* Phase Cycling Tables */
   settable(t1, 2, ph1);
   settable(t2, 32, ph2);
   settable(t3, 8, ph3);
   settable(t4, 32, ph4);
if (iphase == 2) 
{
tsadd(t1,1,4);
}
/* Pulse Sequence */
   /* NOESY */
if (fabs(gzlvl1)>0.0)
{
obspower(tpwr);
   status(A);
      if (sspul[A] == 'y')
       {
        rgpulse(200*pw, zero, rof1, 0.0e-6);
        rgpulse(200*pw, one, 0.0e-6, rof1);
       }
      delay(d1);
   status(B);
     rgpulse(pw, t1, rof1, rof1);
    delay(d2);
     rgpulse(pw, zero, rof1, rof1);
     zgradpulse(gzlvl3,gt3);
    hsdelay(mix-gt3);
     rgpulse(pw, t3, rof1, rof2);
}
else
{       pulse(pw,v1);
}
if (fabs(gzlvl4)>0.0)
{
   /* Pureshift */
    delay(d3/2.0);
    delay((0.25/sw2)-gt2-gstab);
     zgradpulse(gzlvl2*0.5,gt2);                     /* CTP selection */
    delay(gstab);
     rgpulse(pw*2,zero,rof1,rof2);                     /* Hard 180 */
    delay(gstab+0.25/sw2);
     zgradpulse(-gzlvl2*0.5,gt2);                    /* second CTP pulse*/
        obspower(selpwr);                               /* CHANGE POWER to SOFT */
    delay(gstab);
     rgradient('z',gzlvl4);                          /* SLICE selection - PFG  */
     shaped_pulse(selshape,selpw, t2, rof1, rof2);   /* SLICE selection - Soft 180 */     rgradient('z',0.0);
    delay(gstab);
     zgradpulse(-gzlvl2,gt2);                        /* third CTP pulse*/
rcvron();
obsblank();
    delay(gstab-droppts/sw);
    delay(d3/2.0);
     setreceiver(t4);
}
}